//+------------------------------------------------------------------
//-    Num_Aver_of_Ticks / - ,      
//
//
//
//+------------------------------------------------------------------
#property copyright "ROMANBEST"
#property link      "rshiredchenko@mail.ru"

#property indicator_separate_window          // .   
#property indicator_buffers 4                //  
#property indicator_color1 clrLimeGreen      //   0   Bid
#property indicator_color2 clrBlue           //   1   Ask
#property indicator_color4 clrGold           //    


//----  
extern int MaxDrawTicks     =1000;
extern int Num_Aver_of_Ticks=15;
extern int MA_Period        =1;


//---    
double ExtMapBuffer1[];                      //     Bid
double ExtMapBuffer2[];                      //     Ask 
double ExtMapBuffer_Ave_Speed[];             //       
double ExtMapBuffer_MA[];                    //      Bid 
 

              
 
double ExtMapBuffer3[]; // ( )     .  Num_Aver_of_Ticks 
//double ExtMapBuffer3[]; // ( )     .  Num_Aver_of_Ticks 

int size;               //    
double X;               //   
 //         ( i)    i>=0  i<ArraySize(High) 

                                  
int myBars;
int i;
int delimeterCounter;
int _start,tickCounter;
double Sec_at_Num_Aver_of_Ticks; // - ,          
                                 // (Num_Aver_of_Ticks)
  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorDigits(_Digits); //    (    )    . 

   SetIndexBuffer(0, ExtMapBuffer1);           //   Bid 
   SetIndexStyle (0,DRAW_LINE,STYLE_SOLID,2);  //      
   SetIndexEmptyValue(0,0.0);
   
   SetIndexBuffer(1, ExtMapBuffer2);           //   Ask 
   SetIndexStyle (1,DRAW_LINE,STYLE_SOLID,2);  //      
   SetIndexEmptyValue(1,0.0); 
   
   SetIndexBuffer(2, ExtMapBuffer_Ave_Speed);  //   C  
   SetIndexStyle (2,DRAW_NONE);                //         
   SetIndexEmptyValue(2,0.0); 
     

   SetIndexBuffer(3, ExtMapBuffer_MA);         //     Bid 
   SetIndexStyle (3,DRAW_LINE,STYLE_SOLID,1);  //      
   SetIndexEmptyValue(3,0.0); 
   
   
    //---     time[] -     
  // ArraySetAsSeries(time,true); 
   
//---    
   if(ArrayResize(ExtMapBuffer3,MaxDrawTicks)<0) {Print("         "); return(false);}
//---          
    // ArraySetAsSeries(ExtMapBuffer3,true);
    
//---       . 
   size=ArraySize(ExtMapBuffer3);
   if (size>0) Print(" : ",size);
   else Print(".   ",size);     
                                                          // for(int i=0;i<=100;i++) Print(" ExtMapBuffer3[i] = ", ExtMapBuffer3[i]);   
   //---   50   4
 //  ArrayFill(ExtMapBuffer3,0,50,4);
//---  50  (  50-)  8
 //   ArrayFill(ExtMapBuffer3,50,50,8);
//---    
 //  for(int i=0;i<ArraySize(ExtMapBuffer3);i++) Print(" i =  ", i, " ExtMapBuffer3 =  ", ExtMapBuffer3[i]);                      

//   ------------
   
   Print("     ");
   for (i=Bars-1;i>=0;i--) { ExtMapBuffer1[i]=0.0; ExtMapBuffer2[i]=0.0; ExtMapBuffer3[i]=0.0;} 
  
   //---       c   
   _start = GetTickCount();   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void SetDelimeter()
  {
//----
   string delimeterDate=TimeToStr(Time[0]);
   if (myBars!=0)
      {
      Print(" ");      
      int handle=WindowFind("tick_speed Aver 27 c 2016 . V01");
      if(!ObjectCreate(delimeterDate,OBJ_VLINE,handle,Time[0],0))
         {
         Print("      ",
         handle,"   ",TimeToStr(CurTime()));
         Print(" ",GetLastError(),",   ",delimeterDate);
         }
      else 
         {
         ObjectSet(delimeterDate,OBJPROP_COLOR,DarkGreen);
         ObjectSet(delimeterDate,OBJPROP_STYLE,STYLE_DASHDOT);
         ObjectsRedraw();
         }
      }
//----   
  }
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void ShiftArray()
  {
//----
   int V_lines;
   string delimeterName;
   datetime firstTime;
   int BarFirstTime;
   
   if (tickCounter>2*MaxDrawTicks)
      {
      for (i=tickCounter;i>=MaxDrawTicks;i--) { ExtMapBuffer1[i]=0.0; ExtMapBuffer2[i]=0.0; ExtMapBuffer3[i]=0.0; }
      tickCounter=MaxDrawTicks;
      }
   for(int cnt=tickCounter;cnt>0;cnt--)
      {
      ExtMapBuffer1[cnt]=ExtMapBuffer1[cnt-1];
      ExtMapBuffer2[cnt]=ExtMapBuffer2[cnt-1];
      ExtMapBuffer3[cnt]=ExtMapBuffer3[cnt-1];
      }
   V_lines=ObjectsTotal();
   for (int z=0;z<V_lines;z++)
      {
      delimeterName=ObjectName(z); 
      if (ObjectFind(delimeterName)!=-1)
         {
         if (ObjectType(delimeterName)==OBJ_VLINE) 
            {
            firstTime=ObjectGet(delimeterName,OBJPROP_TIME1);
            BarFirstTime=iBarShift(NULL,0,firstTime);
            firstTime=Time[BarFirstTime+1];
            ObjectSet(delimeterName,OBJPROP_TIME1,firstTime); 
            }
         }       
      }
//----   
  }
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
bool isNewBar()
  {
//----
   bool res=false;
   if (myBars!=Bars)
      {
      res=true;
      myBars=Bars;
      }   
//----
   return(res);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {   
  //---    
   // for(int i=0;i<ArraySize(ExtMapBuffer3);i++) Print(" i =  ", i, " ExtMapBuffer3 =  ", ExtMapBuffer3[i]);      
   //---    ,      
   uint time_ms=GetTickCount() - _start;
   //---    ,      
   double time_s=time_ms/1000;
 //  double X;                      //   
   
   int    counted_bars=IndicatorCounted();
//----
   if (isNewBar())
     {
      //  
      //tickCounter++;
      SetDelimeter();
      ExtMapBuffer1[0]=DoubleToStr(Bid,Digits); 
      ExtMapBuffer2[0]=DoubleToStr(Ask,Digits);    
      
      
             //ExtMapBuffer3[0]= time_s;  
      //---  c tickCounter   time_s
     // ArrayFill(ExtMapBuffer3,tickCounter,1,time_s);  
     if (tickCounter >= 0 && tickCounter < ArraySize(ExtMapBuffer3) && tickCounter <= Num_Aver_of_Ticks)    
     {
      //---       time_s
      if (tickCounter == 0) ArrayFill(ExtMapBuffer3,0,1,time_s);
      else                  ArrayFill(ExtMapBuffer3,tickCounter,1,time_s);
      //---   
       for( i=0;i<1;i++) Print(" tickCounter =  ", tickCounter, " ExtMapBuffer3 =  ", ExtMapBuffer3[tickCounter]); 
       if ((ExtMapBuffer3[0] - ExtMapBuffer3[Num_Aver_of_Ticks])!=0)
       ExtMapBuffer_Ave_Speed[0]= Num_Aver_of_Ticks / (ExtMapBuffer3[0] - ExtMapBuffer3[Num_Aver_of_Ticks]);     
     }        
     }
   else
      
     {
      tickCounter++;
      ShiftArray();
      ExtMapBuffer1[0]=DoubleToStr(Bid,Digits); 
      ExtMapBuffer2[0]=DoubleToStr(Ask,Digits);   
     
      ExtMapBuffer3[0]= time_s;  
      //     //    //   // ,         
      //---   ( ) tickCounter    time_s
      //ArrayFill(ExtMapBuffer3,tickCounter,1,time_s);    
                                              // X = tickCounter/time_s;  
       if (tickCounter >= 0 && tickCounter < ArraySize(ExtMapBuffer3) && tickCounter <= Num_Aver_of_Ticks)    
          {
      //---       time_s
            if (tickCounter == 0) ArrayFill(ExtMapBuffer3,0,1,time_s);
            else                  ArrayFill(ExtMapBuffer3,tickCounter,1,time_s);
      //---   
           for( i=0;i<1;i++) Print(" tickCounter =  ", tickCounter, " ExtMapBuffer3 =  ", ExtMapBuffer3[tickCounter]);     
          }                                                                         
     }
 /*    
    if (tickCounter > Num_Aver_of_Ticks)       http://docs.mql4.com/ru/array/arrayminimum      
     ...           ...
        ExtMapBuffer3[Num_Aver_of_Ticks].  , .  .   
    ExtMapBuffer3[]  ExtMapBuffer3[]      Num_Aver_of_Ticks.
    
*/    
      Sec_at_Num_Aver_of_Ticks =  time_s - ExtMapBuffer3[Num_Aver_of_Ticks];
      
      if (tickCounter >= Num_Aver_of_Ticks  && (time_s - ExtMapBuffer3[Num_Aver_of_Ticks])!=0) 
          X = Num_Aver_of_Ticks / (time_s - ExtMapBuffer3[Num_Aver_of_Ticks]);     
         
      ExtMapBuffer_Ave_Speed[0]= NormalizeDouble(X,1);  //     . 
      
      double MA_0=iMAOnArray(ExtMapBuffer1,0,MA_Period,0,MODE_EMA,0); 
      double MA_1=iMAOnArray(ExtMapBuffer1,0,MA_Period,0,MODE_EMA,1); 
      double MA_2=iMAOnArray(ExtMapBuffer1,0,MA_Period,0,MODE_EMA,2); 
   
       


     if (time_s!=0) 
       Comment(
              "tickCounter = ", tickCounter, "\n",
              "secondCounter, time_s  = ",    NormalizeDouble(time_s,2) ,   "\n",
            
              "ExtMapBuffer1[0] = ", DoubleToStr(ExtMapBuffer1[0],Digits) , "\n",
              "ExtMapBuffer2[0] = ", DoubleToStr(ExtMapBuffer2[0],Digits) , "\n",
              "ExtMapBuffer1[1] = ", DoubleToStr(ExtMapBuffer1[1],Digits) , "\n",
              "ExtMapBuffer2[1] = ", DoubleToStr(ExtMapBuffer2[1],Digits) , "\n",
              "ExtMapBuffer1[2] = ", DoubleToStr(ExtMapBuffer1[2],Digits) , "\n",
              "ExtMapBuffer2[2] = ", DoubleToStr(ExtMapBuffer2[2],Digits) , "\n",
                                                                            "\n",
              "ExtMapBuffer_MA[0] = ", DoubleToStr(MA_0,Digits),"\n",
              "ExtMapBuffer_MA[1] = ", DoubleToStr(MA_1,Digits),"\n",
              "ExtMapBuffer_MA[2] = ", DoubleToStr(MA_2,Digits),"\n",
                                                                            "\n",
              "ExtMapBuffer_Ave_Speed[0] = ", NormalizeDouble(ExtMapBuffer_Ave_Speed[0],2) , "\n",
              "ExtMapBuffer3[0] = ", NormalizeDouble(ExtMapBuffer3[0],2) , "\n",
              "ExtMapBuffer3[Num_Aver_of_Ticks] = ", NormalizeDouble(ExtMapBuffer3[Num_Aver_of_Ticks],Digits) , "\n",
              
              "Average speed for average quantity of tics = ", NormalizeDouble(X,2), " Num_Aver_of_Ticks/Sec_at_Num_Aver_of_Ticks ", "\n",
              "Num_Aver_of_Ticks =  ", Num_Aver_of_Ticks,"      Num_Aver_of_Ticks = ",Sec_at_Num_Aver_of_Ticks  , "\n",
              "     Num_Aver_of_Ticks  = ",    NormalizeDouble(ExtMapBuffer3[0]-ExtMapBuffer3[Num_Aver_of_Ticks],Digits) , "\n",
              "Average speed since running = ", NormalizeDouble(tickCounter/time_s,2) , " All Tick/All Second ", "\n",
              
              
           "") ;    
                    
            
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
